-- Compass App
-- Developed by Carlos Yanez

-- Hide Status Bar

display.setStatusBar(display.HiddenStatusBar)

-- Graphics

-- [Background]

local bg = display.newImage('bg.png')

-- [Pointer]

local pointer = display.newImage('pointer.png')

-- Heading Text

local heading = display.newText('0', display.contentCenterX, 60, native.systemFont, 21)

-- Functions

local Main = {}
local update = {}

-- Main Function

function Main()
	pointer:setReferencePoint(display.CenterReferencePoint)
	pointer.x = display.contentCenterX
	pointer.y = display.contentCenterY
	
	heading:setTextColor(255)
	heading:setReferencePoint(display.CenterReferencePoint)
	
	Runtime:addEventListener('heading', update)
end

function update(e)
	-- Pointer Rotation
	
	pointer.rotation = math.floor(e.magnetic)
	
	-- Heading Text & Direction
	
	if(pointer.rotation >= 0 and pointer.rotation < 23) then
		heading.text = math.floor(e.magnetic) .. ' N'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 23 and pointer.rotation < 68) then
		heading.text = math.floor(e.magnetic) .. ' NE'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 68 and pointer.rotation < 113) then
		heading.text = math.floor(e.magnetic) .. ' E'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 113 and pointer.rotation < 158) then
		heading.text = math.floor(e.magnetic) .. ' SE'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 158 and pointer.rotation < 203) then
		heading.text = math.floor(e.magnetic) .. ' S'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 203 and pointer.rotation < 248) then
		heading.text = math.floor(e.magnetic) .. ' SW'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 248 and pointer.rotation < 293) then
		heading.text = math.floor(e.magnetic) .. ' W'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	elseif(pointer.rotation >= 293 and pointer.rotation < 360) then
		heading.text = math.floor(e.magnetic) .. ' NW'
		heading:setReferencePoint(display.CenterReferencePoint)
		heading.x = display.contentCenterX
	end
end

Main()